import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

public class TestSAX2 {

    public static void main(String[] args) throws Exception {
        String uri = args[0];
        new TestSAX2(uri);
    }

    public TestSAX2(String uri) throws Exception {
	SAXParserFactory factory = SAXParserFactory.newInstance();
        factory.setFeature("http://xml.org/sax/features/namespaces", true);
        factory.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
	XMLReader xr = factory.newSAXParser().getXMLReader();
        xr.setContentHandler(new MyHandler());
        xr.parse(uri); 
    }

private class MyHandler extends DefaultHandler {

    public void startElement(
        String nsURI,
	String localName,
	String qName,
        Attributes atts
    ) {
	System.out.println("BEGIN");
	System.out.println(" URI = " + nsURI);
	System.out.println(" local = " + localName);
	System.out.println(" qname = " + qName);
	System.out.println("ATTRIBUTES");
        for (int a=0; a<atts.getLength(); a++) {
            System.out.println(" URI = " + atts.getURI(a));
            System.out.println(" local = " + atts.getLocalName(a));
            System.out.println(" qname = " + atts.getQName(a));
        }
    }

    public void endElement(
        String nsURI,
	String localName,
	String qName
    ) {
	System.out.println("END");
	System.out.println(" URI = " + nsURI);
	System.out.println(" local = " + localName);
	System.out.println(" qname = " + qName);
    }

}

}
