<?xml version="1.0"?>

<!DOCTYPE xsl:stylesheet>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<!-- SAXON: XHTML=yes -->
<xsl:output
            method="xml"
            doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
            doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
            indent="yes"
            encoding="EUC-JP"
/>

<xsl:template match="/">
<html lang="ja" xml:lang="ja">
<head><title>品目リスト</title></head>
<body>
  <h1><div align="center">品目リスト</div></h1>
  <table border="1" rules="all">
    <tr>
    <th>項番</th>
    <th>品名</th>
    <th>単価</th>
    <th>数量</th>
    <th>金額</th>
    </tr>
    <xsl:for-each select="/品目リスト/項目">
       <tr>
       <td><xsl:value-of select="項番"/></td>
       <td><xsl:value-of select="品名"/></td>
       <td align="right"><xsl:value-of select="単価"/></td>
       <td align="right"><xsl:value-of select="数量"/><xsl:value-of select="単位"/></td>
       <td align="right"><xsl:value-of select="金額"/><xsl:value-of select="単価 * 数量" /></td>
       </tr>
    </xsl:for-each>
    <tr>
    <td colspan="4" align="center">合計</td>
    <td align="right"><xsl:call-template name="合計計算" /></td>
    </tr>
  </table>
</body>
</html>
</xsl:template>

<xsl:template name="合計計算">
   <xsl:param name="合計" select="0" />
   <xsl:param name="i" select="1" />
   <xsl:choose>
     <xsl:when test="/品目リスト/項目[position() = $i]">
       <xsl:for-each select="/品目リスト/項目[position() = $i]">
         <xsl:variable name="金額" select="単価 * 数量" />
         <xsl:call-template name="合計計算">
           <xsl:with-param name="合計" select="$合計 + $金額"/>
           <xsl:with-param name="i" select="$i + 1"/>
         </xsl:call-template>
       </xsl:for-each>
     </xsl:when>
     <xsl:otherwise>
        <xsl:value-of select="$合計"/>
     </xsl:otherwise>
   </xsl:choose>
</xsl:template>

</xsl:stylesheet>
